---
title: Basic form hints
slug: Web/Accessibility/ARIA/forms/Basic_form_hints
tags:
  - ARIA
  - Accessibility
  - Forms
---
<p><span class="seoSummary">When implementing forms using traditional HTML form-related elements, it is important to provide labels for controls, and explicitly associate a label with its control.</span> When a screen reader user navigates a page, the screen reader will describe form controls. Without a direct association between the control and its label, the screen reader has no way of knowing which label is the correct one.</p>

<p>The example below shows a simple form with labels. Note that each {{ HTMLElement("input") }} element has an <code>id</code>, and each {{ HTMLElement("label") }} element has a <code>for</code> attribute, indicating the <code>id</code> of the associated {{ HTMLElement("input") }}.</p>

<pre class="brush: html">&lt;form&gt;
  &lt;ul&gt;
    &lt;li&gt;
      &lt;input id="wine-1" type="checkbox" value="riesling"/&gt;
      &lt;label for="wine-1"&gt;Berg Rottland Riesling&lt;/label&gt;
    &lt;/li&gt;
    &lt;li&gt;
      &lt;input id="wine-2" type="checkbox" value="pinot-blanc"/&gt;
      &lt;label for="wine-2"&gt;Pinot Blanc&lt;/label&gt;
    &lt;/li&gt;
    &lt;li&gt;
      &lt;input id="wine-3" type="checkbox" value="pinot-grigio"/&gt;
      &lt;label for="wine-3"&gt;Pinot Grigio&lt;/label&gt;
    &lt;/li&gt;
    &lt;li&gt;
      &lt;input id="wine-4" type="checkbox" value="gewurztraminer"/&gt;
      &lt;label for="wine-4"&gt;Gewürztraminer&lt;/label&gt;
    &lt;/li&gt;
  &lt;/ul&gt;
&lt;/form&gt;
</pre>

<h2 id="Labeling_with_ARIA">Labeling with ARIA</h2>

<p>The HTML {{ HTMLElement("label") }} element is appropriate for form-related elements, but many form controls are implemented as a dynamic JavaScript widget, using {{ HTMLElement("div") }}s or {{ HTMLElement("span") }}s. <a href="https://www.w3.org/WAI/standards-guidelines/aria/" title="http://www.w3.org/WAI/intro/aria.php">WAI-ARIA</a>, the <strong>Accessible Rich Internet Applications</strong> specification from the W3C's <a href="http://www.w3.org/WAI/">Web Accessibility Initiative</a>, provides the <code><a href="http://www.w3.org/TR/2010/WD-wai-aria-20100916/states_and_properties#aria-labelledby">aria-labelledby</a></code> attribute for these cases.</p>

<p>The example below shows a radio button group implemented using an unordered list. Note that on line 3, the {{ HTMLElement("ul") }} element sets the <code>aria-labelledby</code> attribute to <code>rg1_label</code>, the <code>id</code> of the {{ HTMLElement("h3") }} element on line 1, which is the label for the radio group.</p>

<pre class="brush: html">&lt;h3 id="rg1_label"&gt;Lunch Options&lt;/h3&gt;

&lt;ul class="radiogroup" id="rg1"  role="radiogroup" aria-labelledby="rg1_label"&gt;
  &lt;li id="r1"  tabindex="-1" role="radio" aria-checked="false"&gt;
    &lt;img role="presentation" src="radio-unchecked.gif" /&gt; Thai
  &lt;/li&gt;
  &lt;li id="r2"  tabindex="-1" role="radio"  aria-checked="false"&gt;
    &lt;img role="presentation" src="radio-unchecked.gif" /&gt; Subway
  &lt;/li&gt;
  &lt;li id="r3"   tabindex="0" role="radio" aria-checked="true"&gt;
    &lt;img role="presentation" src="radio-checked.gif" /&gt; Radio Maria
  &lt;/li&gt;
&lt;/ul&gt;
</pre>

<h2 id="Describing_with_ARIA">Describing with ARIA</h2>

<p>Form controls sometimes have a description associated with them, in addition to the label. ARIA provides the <code><a href="http://www.w3.org/TR/2010/WD-wai-aria-20100916/states_and_properties#aria-describedby">aria-describedby</a></code> attribute to directly associate the description with the control.</p>

<p>The example below shows a {{ HTMLElement("button") }} element that is described by a sentence in a separate {{ HTMLElement("div") }} element. The <code>aria-describedby</code> attribute on the {{ HTMLElement("button") }} references the <code>id</code> of the {{ HTMLElement("div") }}.</p>

<pre class="brush: html">&lt;button aria-describedby="descriptionRevert"&gt;Revert&lt;/button&gt;
&lt;div id="descriptionRevert"&gt;Reverting will undo any changes that have been made
                            since the last save.&lt;/div&gt;</pre>

<div class="note">
<p><strong>Note</strong>: The <code>aria-describedby</code> attribute is used for other purposes, in addition to form controls.</p>
</div>

<h2 id="Required_and_invalid_fields">Required and invalid fields</h2>

<div class="note">
<p><strong>Note</strong>: Now that <code>required</code> is available to more than 97% of users globally, it is no longer recommended that you use both <code>required</code> and <code>aria-required</code>.</p>
</div>

<p>Web developers typically use presentational strategies to indicate required or invalid fields. Assistive technologies (ATs) cannot necessarily infer this information from the presentation. ARIA provides attributes for indicating that form controls are required or invalid:</p>

<ul>
 <li>The <a href="http://www.w3.org/TR/2010/WD-wai-aria-20100916/states_and_properties#aria-required"><strong>aria-required</strong></a> property can be applied to a form element, to indicate to an AT that it is required to complete the form.</li>
 <li>The <a href="http://www.w3.org/TR/2010/WD-wai-aria-20100916/states_and_properties#aria-invalid"><strong>aria-invalid</strong></a> state can be programmatically applied, to indicate to an AT which data fields have incorrect data, so that the user knows they have entered invalid data.</li>
</ul>

<p>The example below shows a simple form with three fields. On lines 4 and 12, the <code>aria-required</code> attributes are set to true (in addition to the asterisks next to the labels), indicating that the name and email fields are required. The second part of the example, a snippet of JavaScript validates the email format, and sets the <code>aria-invalid</code> attribute of the email field (line 12 of the HTML) according to the result (in addition to changing the presentation of the element).</p>

<pre class="brush: html">&lt;form&gt;
  &lt;div&gt;
    &lt;label for="name"&gt;* Name:&lt;/label&gt;
    &lt;input type="text" value="name" id="name" aria-required="true"/&gt;
  &lt;/div&gt;
  &lt;div&gt;
    &lt;label for="phone"&gt;Phone:&lt;/label&gt;
    &lt;input type="text" value="phone" id="phone" aria-required="false"/&gt;
  &lt;/div&gt;
  &lt;div&gt;
    &lt;label for="email"&gt;* E-mail:&lt;/label&gt;
    &lt;input type="text" value="email" id="email" aria-required="true"/&gt;
  &lt;/div&gt;
&lt;/form&gt;</pre>

<p>The script that validates the form entry would look something like this:</p>

<pre class="brush: js">var validate = function () {
  var emailElement = document.getElementById(emailFieldId);
  var valid = emailValid(formData.email); // returns true if valid, false otherwise

  emailElement.setAttribute("aria-invalid", !valid);
  setElementBorderColour(emailElement, valid); // sets the border to red if second arg is false
};
</pre>

<h2 id="Providing_Helpful_Error_Messages">Providing Helpful Error Messages</h2>

<p>Read how to use <a href="/en-US/docs/aria/forms/alerts" title="aria/forms/alerts">ARIA alerts to enhance forms</a>.</p>

<p>For more guidance on using ARIA for forms accessibility, see the <a href="http://www.w3.org/TR/wai-aria-practices/">WAI-ARIA Authoring Practices</a> document.</p>
